/*
 * tp_paths.cu
 *
 *  Created on: Mar 26, 2025
 *      Author: elphel
 */
#include "tp_paths.h"
TpPaths::TpPaths(int lwir){
	// values for LWIR sensors
	const char* kernel_file_lwir[16] = {
			"clt/aux_chn0_transposed.kernel",
			"clt/aux_chn1_transposed.kernel",
			"clt/aux_chn2_transposed.kernel",
			"clt/aux_chn3_transposed.kernel",
			"clt/aux_chn4_transposed.kernel",
			"clt/aux_chn5_transposed.kernel",
			"clt/aux_chn6_transposed.kernel",
			"clt/aux_chn7_transposed.kernel",
			"clt/aux_chn8_transposed.kernel",
			"clt/aux_chn9_transposed.kernel",
			"clt/aux_chn10_transposed.kernel",
			"clt/aux_chn11_transposed.kernel",
			"clt/aux_chn12_transposed.kernel",
			"clt/aux_chn13_transposed.kernel",
			"clt/aux_chn14_transposed.kernel",
			"clt/aux_chn15_transposed.kernel"};

	const char* kernel_offs_file_lwir[16] = {
			"clt/aux_chn0_transposed.kernel_offsets",
			"clt/aux_chn1_transposed.kernel_offsets",
			"clt/aux_chn2_transposed.kernel_offsets",
			"clt/aux_chn3_transposed.kernel_offsets",
			"clt/aux_chn4_transposed.kernel_offsets",
			"clt/aux_chn5_transposed.kernel_offsets",
			"clt/aux_chn6_transposed.kernel_offsets",
			"clt/aux_chn7_transposed.kernel_offsets",
			"clt/aux_chn8_transposed.kernel_offsets",
			"clt/aux_chn9_transposed.kernel_offsets",
			"clt/aux_chn10_transposed.kernel_offsets",
			"clt/aux_chn11_transposed.kernel_offsets",
			"clt/aux_chn12_transposed.kernel_offsets",
			"clt/aux_chn13_transposed.kernel_offsets",
			"clt/aux_chn14_transposed.kernel_offsets",
			"clt/aux_chn15_transposed.kernel_offsets"};

	const char* image_files_lwir[16] = {
			"clt/aux_chn0.bayer",
			"clt/aux_chn1.bayer",
			"clt/aux_chn2.bayer",
			"clt/aux_chn3.bayer",
			"clt/aux_chn4.bayer",
			"clt/aux_chn5.bayer",
			"clt/aux_chn6.bayer",
			"clt/aux_chn7.bayer",
			"clt/aux_chn8.bayer",
			"clt/aux_chn9.bayer",
			"clt/aux_chn10.bayer",
			"clt/aux_chn11.bayer",
			"clt/aux_chn12.bayer",
			"clt/aux_chn13.bayer",
			"clt/aux_chn14.bayer",
			"clt/aux_chn15.bayer"};

	const char* ports_offs_xy_file_lwir[16] = {
			"clt/aux_chn0.portsxy",
			"clt/aux_chn1.portsxy",
			"clt/aux_chn2.portsxy",
			"clt/aux_chn3.portsxy",
			"clt/aux_chn4.portsxy",
			"clt/aux_chn5.portsxy",
			"clt/aux_chn6.portsxy",
			"clt/aux_chn7.portsxy",
			"clt/aux_chn8.portsxy",
			"clt/aux_chn9.portsxy",
			"clt/aux_chn10.portsxy",
			"clt/aux_chn11.portsxy",
			"clt/aux_chn12.portsxy",
			"clt/aux_chn13.portsxy",
			"clt/aux_chn14.portsxy",
			"clt/aux_chn15.portsxy"};

	//#ifndef DBG_TILE
	const char* ports_clt_file_lwir[16] = { // never referenced
			"clt/aux_chn0.clt",
			"clt/aux_chn1.clt",
			"clt/aux_chn2.clt",
			"clt/aux_chn3.clt",
			"clt/aux_chn4.clt",
			"clt/aux_chn5.clt",
			"clt/aux_chn6.clt",
			"clt/aux_chn7.clt",
			"clt/aux_chn8.clt",
			"clt/aux_chn9.clt",
			"clt/aux_chn10.clt",
			"clt/aux_chn11.clt",
			"clt/aux_chn12.clt",
			"clt/aux_chn13.clt",
			"clt/aux_chn14.clt",
			"clt/aux_chn15.clt"};

	const char* result_rbg_file_lwir[16] = {
			"clt/aux_chn0.rbg",
			"clt/aux_chn1.rbg",
			"clt/aux_chn2.rbg",
			"clt/aux_chn3.rbg",
			"clt/aux_chn4.rbg",
			"clt/aux_chn5.rbg",
			"clt/aux_chn6.rbg",
			"clt/aux_chn7.rbg",
			"clt/aux_chn8.rbg",
			"clt/aux_chn9.rbg",
			"clt/aux_chn10.rbg",
			"clt/aux_chn11.rbg",
			"clt/aux_chn12.rbg",
			"clt/aux_chn13.rbg",
			"clt/aux_chn14.rbg",
			"clt/aux_chn15.rbg"};
	//#endif
	/*
	const char* result_corr_file_lwir =          "clt/aux_corr.corr";
	const char* result_corr_quad_file_lwir =     "clt/aux_corr-quad.corr";
	const char* result_corr_td_norm_file_lwir =  "clt/aux_corr-td-norm.corr";
	const char* result_inter_td_norm_file_lwir = "clt/aux_inter-td-norm.corr";
	const char* result_textures_file_lwir =      "clt/aux_texture_nodp.rgba";
	const char* result_diff_rgb_combo_file_lwir ="clt/aux_diff_rgb_combo_nodp.drbg";
	const char* result_textures_rgba_file_lwir = "clt/aux_texture_rgba_nodp.rgba";

	const char* result_textures_file_dp_lwir =      "clt/aux_texture_dp.rgba";
	const char* result_diff_rgb_combo_file_dp_lwir ="clt/aux_diff_rgb_combo_dp.drbg";
	const char* result_textures_rgba_file_dp_lwir = "clt/aux_texture_rgba_dp.rgba";
	const char* rByRDist_file_lwir =             "clt/aux.rbyrdist";
	const char* correction_vector_file_lwir =    "clt/aux.correction_vector";
	const char* geometry_correction_file_lwir =  "clt/aux.geometry_correction";

	float color_weights_lwir [3] = {
			1.0,              // float             weight0,            // scale for R 0.5 / (1.0 + 0.5 +0.2)
			1.0,              // float             weight1,            // scale for B 0.2 / (1.0 + 0.5 +0.2)
			1.0};             // float             weight2,            // scale for G 1.0 / (1.0 + 0.5 +0.2)
	float generate_RBGA_params_lwir[5]={
			10.0,                  // float             min_shot,           // 10.0
			3.0,                   // float             scale_shot,         // 3.0
			10.0, // 1.5f,                  // float             diff_sigma,         // pixel value/pixel change
			10.0f,                 // float             diff_threshold,     // pixel value/pixel change
			12.0    // 3.0         // float             min_agree,          // minimal number of channels to agree on a point (real number to work with fuzzy averages)
	};
*/
	// values for RGB sensors
	const char* kernel_file_rgb[4] = {
			"clt/main_chn0_transposed.kernel",
			"clt/main_chn1_transposed.kernel",
			"clt/main_chn2_transposed.kernel",
			"clt/main_chn3_transposed.kernel"};

	const char* kernel_offs_file_rgb[4] = {
			"clt/main_chn0_transposed.kernel_offsets",
			"clt/main_chn1_transposed.kernel_offsets",
			"clt/main_chn2_transposed.kernel_offsets",
			"clt/main_chn3_transposed.kernel_offsets"};

	const char* image_files_rgb[4] = {
			"clt/main_chn0.bayer",
			"clt/main_chn1.bayer",
			"clt/main_chn2.bayer",
			"clt/main_chn3.bayer"};

	const char* ports_offs_xy_file_rgb[4] = {
			"clt/main_chn0.portsxy",
			"clt/main_chn1.portsxy",
			"clt/main_chn2.portsxy",
			"clt/main_chn3.portsxy"};
	const char* ports_clt_file_rgb[4] = { // never referenced
			"clt/main_chn0.clt",
			"clt/main_chn1.clt",
			"clt/main_chn2.clt",
			"clt/main_chn3.clt"};
	const char* result_rbg_file_rgb[4] = {
			"clt/main_chn0.rbg",
			"clt/main_chn1.rbg",
			"clt/main_chn2.rbg",
			"clt/main_chn3.rbg"};
	//#endif
	/*
	const char* result_corr_file_rgb =           "clt/main_corr.corr";
	const char* result_corr_quad_file_rgb =      "clt/main_corr-quad.corr";
	const char* result_corr_td_norm_file_rgb =   "clt/aux_corr-td-norm.corr";
	///    const char* result_corr_cross_file = "clt/main_corr-cross.corr";
	const char* result_inter_td_norm_file_rgb =  "clt/aux_inter-td-norm.corr";
	const char* result_textures_file_rgb =       "clt/main_texture_nodp.rgba";
	const char* result_diff_rgb_combo_file_rgb = "clt/main_diff_rgb_combo_nodp.drbg";
	const char* result_textures_rgba_file_rgb =  "clt/main_texture_rgba_nodp.rgba";

	const char* result_textures_file_dp_rgb =       "clt/main_texture_dp.rgba";
	const char* result_diff_rgb_combo_file_dp_rgb = "clt/main_diff_rgb_combo_dp.drbg";
	const char* result_textures_rgba_file_dp_rgb =  "clt/main_texture_rgba_dp.rgba";


	const char* rByRDist_file_rgb =            "clt/main.rbyrdist";
	const char* correction_vector_file_rgb =   "clt/main.correction_vector";
	const char* geometry_correction_file_rgb = "clt/main.geometry_correction";
*/
	/*
	float color_weights_rgb [3] = {
			0.294118,              // float             weight0,            // scale for R 0.5 / (1.0 + 0.5 +0.2)
			0.117647,              // float             weight1,            // scale for B 0.2 / (1.0 + 0.5 +0.2)
			0.588235};              // float             weight2,            // scale for G 1.0 / (1.0 + 0.5 +0.2)
	float generate_RBGA_params_rgb[5]={
			10.0,                  // float             min_shot,           // 10.0
			3.0,                   // float             scale_shot,         // 3.0
			1.5f,                  // float             diff_sigma,         // pixel value/pixel change
			10.0f,                 // float             diff_threshold,     // pixel value/pixel change
			3.0                    // float             min_agree,          // minimal number of channels to agree on a point (real number to work with fuzzy averages)
	};
	*/
	/*
	const char ** kernel_file;
	const char ** kernel_offs_file;
	const char ** image_files;
	const char ** ports_offs_xy_file;
	const char ** ports_clt_file;
	const char ** result_rbg_file;

	const char* result_corr_file;
	const char* result_corr_quad_file;
	const char* result_corr_td_norm_file;
	const char* result_inter_td_norm_file;
	const char* result_textures_file;
	const char* result_diff_rgb_combo_file;
	const char* result_textures_rgba_file;
	const char* result_textures_file_dp;
	const char* result_diff_rgb_combo_file_dp;
	const char* result_textures_rgba_file_dp;
	const char* rByRDist_file;
	const char* correction_vector_file;
	const char* geometry_correction_file;
	const float* color_weights;
	const float* generate_RBGA_params;
*/
	kernel_file =                   lwir? kernel_file_lwir :        kernel_file_rgb;
	kernel_offs_file =              lwir? kernel_offs_file_lwir :   kernel_offs_file_rgb;
	image_files =                   lwir? image_files_lwir :        image_files_rgb;
	ports_offs_xy_file =            lwir? ports_offs_xy_file_lwir : ports_offs_xy_file_rgb;
	ports_clt_file =                lwir? ports_clt_file_lwir :     ports_clt_file_rgb;
	result_rbg_file =               lwir? result_rbg_file_lwir :    result_rbg_file_rgb;
	result_corr_file =              lwir ? "clt/aux_corr.corr" :                 "clt/main_corr.corr";
	result_corr_quad_file =         lwir ? "clt/aux_corr-quad.corr" :            "clt/main_corr-quad.corr";
	result_corr_td_norm_file =      lwir ? "clt/aux_corr-td-norm.corr":          "clt/aux_corr-td-norm.corr";
	result_inter_td_norm_file =     lwir ? "clt/aux_inter-td-norm.corr" :        "clt/aux_inter-td-norm.corr";
	result_textures_file =          lwir ? "clt/aux_texture_nodp.rgba" :         "clt/main_texture_nodp.rgba";
	result_diff_rgb_combo_file =    lwir ? "clt/aux_diff_rgb_combo_nodp.drbg" :  "clt/main_diff_rgb_combo_nodp.drbg";
	result_textures_rgba_file =     lwir ? "clt/aux_texture_rgba_nodp.rgba" :    "clt/main_texture_rgba_nodp.rgba";
	result_textures_file_dp =       lwir ? "clt/aux_texture_dp.rgba" :           "clt/main_texture_dp.rgba";
	result_diff_rgb_combo_file_dp = lwir ? "clt/aux_diff_rgb_combo_dp.drbg" :    "clt/main_diff_rgb_combo_dp.drbg";
	result_textures_rgba_file_dp =  lwir ? "clt/aux_texture_rgba_dp.rgba" :      "clt/main_texture_rgba_dp.rgba";
	rByRDist_file =                 lwir ? "clt/aux.rbyrdist" :                  "clt/main.rbyrdist";
	correction_vector_file =        lwir ? "clt/aux.correction_vector" :         "clt/main.correction_vector";
	geometry_correction_file =      lwir ? "clt/aux.geometry_correction" :       "clt/main.geometry_correction";
//	color_weights =                 lwir ? color_weights_lwir :              color_weights_rgb;
//	generate_RBGA_params =          lwir ? generate_RBGA_params_lwir :       generate_RBGA_params_rgb;
}



